#!/usr/bin/env python
# -*- coding: utf-8 -*-
import json

from alipay.aop.api.constant.ParamConstants import *


class UserProfileDetail(object):

    def __init__(self):
        self._user_id = None
        self._user_issuer = None

    @property
    def user_id(self):
        return self._user_id

    @user_id.setter
    def user_id(self, value):
        self._user_id = value
    @property
    def user_issuer(self):
        return self._user_issuer

    @user_issuer.setter
    def user_issuer(self, value):
        self._user_issuer = value


    def to_alipay_dict(self):
        params = dict()
        if self.user_id:
            if hasattr(self.user_id, 'to_alipay_dict'):
                params['user_id'] = self.user_id.to_alipay_dict()
            else:
                params['user_id'] = self.user_id
        if self.user_issuer:
            if hasattr(self.user_issuer, 'to_alipay_dict'):
                params['user_issuer'] = self.user_issuer.to_alipay_dict()
            else:
                params['user_issuer'] = self.user_issuer
        return params

    @staticmethod
    def from_alipay_dict(d):
        if not d:
            return None
        o = UserProfileDetail()
        if 'user_id' in d:
            o.user_id = d['user_id']
        if 'user_issuer' in d:
            o.user_issuer = d['user_issuer']
        return o


