#!/usr/bin/env python
# -*- coding: utf-8 -*-
import json

from alipay.aop.api.FileItem import FileItem
from alipay.aop.api.constant.ParamConstants import *




class AlipayPassCodeAddRequest(object):

    def __init__(self, biz_model=None):
        self._biz_model = biz_model
        self._file_content = None
        self._recognition_info = None
        self._recognition_type = None
        self._verify_type = None
        self._version = "1.0"
        self._terminal_type = None
        self._terminal_info = None
        self._prod_code = None
        self._notify_url = None
        self._return_url = None
        self._udf_params = None
        self._need_encrypt = False

    @property
    def biz_model(self):
        return self._biz_model

    @biz_model.setter
    def biz_model(self, value):
        self._biz_model = value

    @property
    def file_content(self):
        return self._file_content

    @file_content.setter
    def file_content(self, value):
        self._file_content = value
    @property
    def recognition_info(self):
        return self._recognition_info

    @recognition_info.setter
    def recognition_info(self, value):
        self._recognition_info = value
    @property
    def recognition_type(self):
        return self._recognition_type

    @recognition_type.setter
    def recognition_type(self, value):
        self._recognition_type = value
    @property
    def verify_type(self):
        return self._verify_type

    @verify_type.setter
    def verify_type(self, value):
        if isinstance(value, list):
            self._verify_type = list()
            for i in value:
                self._verify_type.append(i)


    @property
    def version(self):
        return self._version

    @version.setter
    def version(self, value):
        self._version = value

    @property
    def terminal_type(self):
        return self._terminal_type

    @terminal_type.setter
    def terminal_type(self, value):
        self._terminal_type = value

    @property
    def terminal_info(self):
        return self._terminal_info

    @terminal_info.setter
    def terminal_info(self, value):
        self._terminal_info = value

    @property
    def prod_code(self):
        return self._prod_code

    @prod_code.setter
    def prod_code(self, value):
        self._prod_code = value

    @property
    def notify_url(self):
        return self._notify_url

    @notify_url.setter
    def notify_url(self, value):
        self._notify_url = value

    @property
    def return_url(self):
        return self._return_url

    @return_url.setter
    def return_url(self, value):
        self._return_url = value

    @property
    def udf_params(self):
        return self._udf_params

    @udf_params.setter
    def udf_params(self, value):
        if not isinstance(value, dict):
            return
        self._udf_params = value

    @property
    def need_encrypt(self):
        return self._need_encrypt

    @need_encrypt.setter
    def need_encrypt(self, value):
        self._need_encrypt = value

    def add_other_text_param(self, key, value):
        if not self.udf_params:
            self.udf_params = dict()
        self.udf_params[key] = value

    def get_params(self):
        params = dict()
        params[P_METHOD] = 'alipay.pass.code.add'
        params[P_VERSION] = self.version
        if self.biz_model:
            params[P_BIZ_CONTENT] = json.dumps(obj=self.biz_model.to_alipay_dict(), ensure_ascii=False, sort_keys=True, separators=(',', ':'))
        if self.file_content:
            if hasattr(self.file_content, 'to_alipay_dict'):
                params['file_content'] = json.dumps(obj=self.file_content.to_alipay_dict(), ensure_ascii=False, sort_keys=True, separators=(',', ':'))
            else:
                params['file_content'] = self.file_content
        if self.recognition_info:
            if hasattr(self.recognition_info, 'to_alipay_dict'):
                params['recognition_info'] = json.dumps(obj=self.recognition_info.to_alipay_dict(), ensure_ascii=False, sort_keys=True, separators=(',', ':'))
            else:
                params['recognition_info'] = self.recognition_info
        if self.recognition_type:
            if hasattr(self.recognition_type, 'to_alipay_dict'):
                params['recognition_type'] = json.dumps(obj=self.recognition_type.to_alipay_dict(), ensure_ascii=False, sort_keys=True, separators=(',', ':'))
            else:
                params['recognition_type'] = self.recognition_type
        if self.verify_type:
            if isinstance(self.verify_type, list):
                for i in range(0, len(self.verify_type)):
                    element = self.verify_type[i]
                    if hasattr(element, 'to_alipay_dict'):
                        self.verify_type[i] = element.to_alipay_dict()
                params['verify_type'] = json.dumps(obj=self.verify_type, ensure_ascii=False, sort_keys=True, separators=(',', ':'))
        if self.terminal_type:
            params['terminal_type'] = self.terminal_type
        if self.terminal_info:
            params['terminal_info'] = self.terminal_info
        if self.prod_code:
            params['prod_code'] = self.prod_code
        if self.notify_url:
            params['notify_url'] = self.notify_url
        if self.return_url:
            params['return_url'] = self.return_url
        if self.udf_params:
            params.update(self.udf_params)
        return params

    def get_multipart_params(self):
        multipart_params = dict()
        return multipart_params
